!
!  Tower of Hanoi
!
!    Input:
!
!      %o0 = number of disks to move (1..n)
!      %o1 = which tower to move from (1,2,3)
!      %o2 = which tower to move to (1,2,3)
!
	.global	_start
_start:
	mov	0,%g5		! initialize counter
	mov	4,%o0		! set up test data
	mov	1,%o1
	call	hanoi
	mov	2,%o2
	.word	0		! illegal instr halt

	.global	hanoi
hanoi:
	cmp	%o0,1		! see if there's just one to move
	ble	print_i1i2	! if so, print out message to move it
	save	%sp,-96,%sp	! meanwhile, make a call frame

	! %i0 = total number to move
	! %i1 = move from
	! %i2 = move to

	sub	%i0,1,%o0	! move n-1
	mov	%i1,%o1		! from i1
	call	hanoi
	xor	%i1,%i2,%o2	! to temp

	mov	%i1,%o1		! print 'move one from i1 to i2'
	call	print_o1o2
	mov	%i2,%o2

	restore			! pop call frame

	! %i0 = total number to move
	! %i1 = original from (now empty)
	! %i2 = original to (now has biggest one)

	sub	%o0,1,%o0	! move n-1
	ba	hanoi		! to i2
	xor	%o1,%o2,%o1	! from temp

	! print message to move a disk

print_i1i2:
	! %i1 = from; %i2 = to
	restore
print_o1o2:
	! %o1 = from; %o2 = to

	add	%g5,1,%g5
	mov	%g5,%o3
	sethi	%hi(print_format),%o0
	add	%o0,%lo(print_format),%o0
	ba,a	printf

print_format:	.ascii	"Move disk from %d to %d (step %d)",10,0
