	.align	4
!
!   Multiply
!
!     Input:
!
!       o0 = multiplicand
!       o1 = multiplier
!
!     Output:
!
!       o0 = low order result
!
!     Scratch:
!
	.global	.mul
.mul:
	st	%o0,[%g0+IODevMulM1]
	st	%o1,[%g0+IODevMulM2]
	retl
	ld	[%g0+IODevMulSPL],%o0

	.global	.umul
.umul:
	st	%o0,[%g0+IODevMulM1]
	st	%o1,[%g0+IODevMulM2]
	retl
	ld	[%g0+IODevMulUPL],%o0
!
!   Division
!
!     Input:
!
!       %o0 = dividend
!       %o1 = divisor
!	%o2 = high-order dividend (.divx/.udivx only)
!
!     Output:
!
!       %o0 = quotient or remainder
!
	.global	.div
	.global	.divx
.div:
	sra	%o0,31,%o2
.divx:
	st	%o2,[%g0+IODevDivDH]
	st	%o0,[%g0+IODevDivDL]
	st	%o1,[%g0+IODevDivDiv]
	retl
	ld	[%g0+IODevDivSQ],%o0

	.global	.rem
	.global	.remx
.rem:
	sra	%o0,31,%o2
.remx:
	st	%o2,[%g0+IODevDivDH]
	st	%o0,[%g0+IODevDivDL]
	st	%o1,[%g0+IODevDivDiv]
	retl
	ld	[%g0+IODevDivSR],%o0

	.global	.udiv
	.global	.udivx
.udiv:
	mov	0,%o2
.udivx:
	st	%o2,[%g0+IODevDivDH]
	st	%o0,[%g0+IODevDivDL]
	st	%o1,[%g0+IODevDivDiv]
	retl
	ld	[%g0+IODevDivUQ],%o0

	.global	.urem
	.global	.uremx
.urem:
	mov	0,%o2
.uremx:
	st	%o2,[%g0+IODevDivDH]
	st	%o0,[%g0+IODevDivDL]
	st	%o1,[%g0+IODevDivDiv]
	retl
	ld	[%g0+IODevDivUR],%o0
